Index: cprs/trunk/CPRS-Chart/fGraphs.pas
===================================================================
--- cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 830)
@@ -588,27 +619,62 @@
 var
   i: integer;
-begin
-  with cboViewsTop do
-  begin
-    Items.Clear;
-    Sorted := false;
-    lstTemp.Sorted := true;
-    FastAssign(rpcGetGraphProfiles('1', '0', 0), lstTemp.Items);
-    if lstTemp.Items.Count > 0 then
-    begin
-      for i := 0 to lstTemp.Items.Count - 1 do
-        Items.Add('-1^' + lstTemp.Items[i] + '^');
-    end;
-    FastAssign(rpcGetGraphProfiles('1', '1', 0), lstTemp.Items);
-    if lstTemp.Items.Count > 0 then
-    begin
-      Items.Add(LLS_LINE);
-      for i := 0 to lstTemp.Items.Count - 1 do
-        Items.Add('-2^' + lstTemp.Items[i] + '^');
-    end;
-    Items.Insert(0, '^<clear all selections>^0');
-    Items.Insert(1, '^<select items>^0');
-  end;
-  FastAssign(cboViewsTop.Items, cboViewsBottom.Items);
+  listline: string;
+begin
+  lstViewsTop.Tag := BIG_NUMBER;
+  lstViewsBottom.Tag := BIG_NUMBER;
+  lstViewsTop.Sorted := false;
+  lstViewsBottom.Sorted := false;
+  lstViewsTop.Items.Clear;
+  lstViewsBottom.Items.Clear;
+  GtslViewPersonal.Sorted := true;
+  FastAssign(GetGraphProfiles('1', '0', 0, User.DUZ), GtslViewPersonal);
+  GtslViewPublic.Sorted := true;
+  FastAssign(GetGraphProfiles('1', '1', 0, 0), GtslViewPublic);
+  with lstViewsTop do
+  begin
+    if GtslViews.Count > 0 then
+    begin
+      if not ((GtslViews.Count = 1) and (Piece(GtslViews[0], '^', 1) = VIEW_CURRENT)) then
+      begin
+        Items.Add(LLS_FRONT + copy('Temporary Views' + LLS_BACK, 0, 60) + '^0');
+        for i := 0 to GtslViews.Count - 1 do
+        begin
+          listline := GtslViews[i];
+          if Piece(listline, '^', 1) <> VIEW_CURRENT then
+            Items.Add(VIEW_TEMPORARY + '^' + listline + '^');
+        end;
+      end;
+    end;
+    if GtslViewPersonal.Count > 0 then
+    begin
+      Items.Add(LLS_FRONT + copy('Personal Views' + LLS_BACK, 0, 60) + '^0');
+      for i := 0 to GtslViewPersonal.Count - 1 do
+        Items.Add(VIEW_PERSONAL + '^' + GtslViewPersonal[i] + '^');
+    end;
+    if GtslViewPublic.Count > 0 then
+    begin
+      Items.Add(LLS_FRONT + copy('Public Views' + LLS_BACK, 0, 60) + '^0');
+      for i := 0 to GtslViewPublic.Count - 1 do
+        Items.Add(VIEW_PUBLIC + '^' + GtslViewPublic[i] + '^');
+    end;
+    AddOnLabGroups(lstViewsTop, 0);
+  end;
+  FastAssign(lstViewsTop.Items, lstViewsBottom.Items);
+end;
+
+procedure TfrmGraphs.AddOnLabGroups(aListBox: TORListBox; personien: integer);
+var
+  i: integer;
+begin
+  if personien < 1 then personien := User.DUZ;
+  FastAssign(rpcTestGroups(personien), GtslLabGroup);
+  GtslLabGroup.Sorted := true;
+  if GtslLabGroup.Count > 0 then
+  begin
+    aListBox.Items.Add(LLS_FRONT + copy('Lab Groups' + LLS_BACK, 0, 60) + '^0');
+    for i := 0 to GtslLabGroup.Count - 1 do
+      aListBox.Items.Add(VIEW_LABS + '^' + Piece(GtslLabGroup[i], '^', 2)
+        + '^' + Piece(GtslLabGroup[i], '^', 1) + '^' + inttostr(personien));
+  end;
 end;
 
@@ -646,22 +712,31 @@
     end;
   end;
-  if cboDateRange.ItemIndex < 0 then
-    cboDateRange.ItemIndex := cboDateRange.Items.Count - 1;
+  DateDefaults;
   cboDateRangeChange(self);
   lvwItemsTopClick(self);
   if lvwItemsTop.Items.Count = 0 then
   begin
-    cboViewsTop.ItemIndex := 0;
-    cboViewsTop.Text := '';
-  end;
-  //else
-  //  lvwItemsTop.SetFocus;
-  //chkItemsTop.SetFocus;
-  cboViewsTop.SetFocus;
-  //Perform(WM_NextDlgCtl, 0, 0);
+    lstViewsTop.ItemIndex := -1
+  end;
+  if not mnuPopGraphViewDefinition.Checked then
+    mnuPopGraphViewDefinitionClick(self);
+  tsTopCustom.TabVisible := false;
+  tsBottomCustom.TabVisible := false;
+end;
+
+procedure TfrmGraphs.DateDefaults;
+begin
+  if Patient.Inpatient then
+     cboDateRange.SelectByID(GetDefaultInpatientDate)
+  else
+     cboDateRange.SelectByID(GetDefaultOutpatientDate);
+  if cboDateRange.ItemIndex < 0 then
+    cboDateRange.ItemIndex := cboDateRange.Items.Count - 1;
 end;
 
 procedure TfrmGraphs.FormClose(Sender: TObject; var Action: TCloseAction);
 begin
+  if btnClose.Tag = 1 then
+    exit;
   SetSize;
   timHintPause.Enabled := false;
@@ -671,4 +746,39 @@
 
 procedure TfrmGraphs.GetSize;
+
+  procedure SetWidth(aListView: TListView; v1, v2, v3, v4: integer);
+  begin
+    if v1 > 0 then aListView.Column[0].Width := v1;
+    if v2 > 0 then aListView.Column[1].Width := v2;
+    if v3 > 0 then aListView.Column[2].Width := v3;
+    if v4 > 0 then aListView.Column[3].Width := v4;
+  end;
+
+  procedure Layout(name, FR: string; v1, v2, v3, v4: integer);
+  begin  // FR indicates Float or Report graph
+    if name = (FR + 'WIDTH') then
+    begin
+      if v1 > 0 then
+      begin
+        pnlItemsTop.Width := v1;
+        splItemsTopMoved(self);
+      end;
+    end
+    else if name = (FR + 'BOTTOM') then
+    begin
+      if v1 > 0 then
+      begin
+        chkDualViews.Checked := true;
+        chkDualViewsClick(self);
+        pnlBottom.Height := v1;
+      end;
+    end
+    else if name = (FR + 'COLUMN') then
+      SetWidth(lvwItemsTop, v1, v2, v3, v4)
+    else if name = (FR + 'BCOLUMN') then
+      SetWidth(lvwItemsBottom, v1, v2, v3, v4);
+  end;
+
+
 var
   i, v1, v2, v3, v4: integer;
@@ -697,75 +807,15 @@
           else
           begin
-            if v1 > 0 then Left := v1;
-            if v2 > 0 then Top := v2;
-            if v3 > 0 then Width := v3;
+            if v1 > 0 then Left :=   v1;
+            if v2 > 0 then Top :=    v2;
+            if v3 > 0 then Width :=  v3;
             if v4 > 0 then Height := v4;
           end;
         end
-        else if name = 'FWIDTH' then
-        begin
-          if v1 > 0 then
-          begin
-            pnlItemsTop.Width := v1;
-            splItemsTopMoved(self);
-          end;
-        end
-        else if name = 'FBOTTOM' then
-        begin
-          if v1 > 0 then
-          begin
-            chkDualViews.Checked := true;
-            chkDualViewsClick(self);
-            pnlBottom.Height := v1;
-          end;
-        end
-        else if name = 'FCOLUMN' then
-        begin
-          if v1 > 0 then lvwItemsTop.Column[0].Width := v1;
-          if v2 > 0 then lvwItemsTop.Column[1].Width := v2;
-          if v3 > 0 then lvwItemsTop.Column[2].Width := v3;
-          if v4 > 0 then lvwItemsTop.Column[3].Width := v4;
-        end
-        else if name = 'FBCOLUMN' then
-        begin
-          if v1 > 0 then lvwItemsBottom.Column[0].Width := v1;
-          if v2 > 0 then lvwItemsBottom.Column[1].Width := v2;
-          if v3 > 0 then lvwItemsBottom.Column[2].Width := v3;
-          if v4 > 0 then lvwItemsBottom.Column[3].Width := v4;
-        end;
+        else
+          Layout(name, 'F', v1, v2, v3, v4);
       end
       else
-      begin
-        if name = 'RWIDTH' then
-        begin
-          if v1 > 0 then
-          begin
-            pnlItemsTop.Width := v1;
-            splItemsTopMoved(self);
-          end;
-        end
-        else if name = 'RBOTTOM' then
-        begin
-          if v1 > 0 then
-          begin
-            pnlBottom.Height := v1;
-            splGraphsMoved(splGraphs);
-          end;
-        end
-        else if name = 'RCOLUMN' then
-        begin
-          if v1 > 0 then lvwItemsTop.Column[0].Width := v1;
-          if v2 > 0 then lvwItemsTop.Column[1].Width := v2;
-          if v3 > 0 then lvwItemsTop.Column[2].Width := v3;
-          if v4 > 0 then lvwItemsTop.Column[3].Width := v4;
-        end
-        else if name = 'RBCOLUMN' then
-        begin
-          if v1 > 0 then lvwItemsBottom.Column[0].Width := v1;
-          if v2 > 0 then lvwItemsBottom.Column[1].Width := v2;
-          if v3 > 0 then lvwItemsBottom.Column[2].Width := v3;
-          if v4 > 0 then lvwItemsBottom.Column[3].Width := v4;
-        end;
-      end;
+        Layout(name, 'R', v1, v2, v3, v4);
     end;
   end;
@@ -774,6 +824,32 @@
 
 procedure TfrmGraphs.SetSize;
-var
-  name, v1, v2, v3, v4: string;
+
+  procedure GetWidth(aListView: TListView; var v1, v2, v3, v4: string);
+  begin
+    v1 := inttostr(aListView.Column[0].Width);
+    v2 := inttostr(aListView.Column[1].Width);
+    v3 := inttostr(aListView.Column[2].Width);
+    v4 := inttostr(aListView.Column[3].Width);
+  end;
+
+  procedure Layout(aList: TStrings; FR, v1, v2, v3, v4: string);
+  begin // FR indicates Float or Report graph
+    v1 := inttostr(splItemsTop.Left);
+    aList.Add(FR + 'WIDTH^' + v1);
+    if chkDualViews.Checked then
+      v1 := inttostr(pnlBottom.Height)
+    else
+      v1 := '0';
+    aList.Add(FR + 'BOTTOM^' + v1);
+    GetWidth(lvwItemsTop, v1, v2, v3, v4);
+    aList.Add(FR + 'COLUMN^' + v1 + ',' + v2 + ',' + v3 + ',' + v4);
+    GetWidth(lvwItemsBottom, v1, v2, v3, v4);
+    aList.Add(FR + 'BCOLUMN^' + v1 + ',' + v2 + ',' + v3 + ',' + v4);
+  end;
+
+
+var
+  v1, v2, v3, v4: string;
+  //values: array[0..3] of string;
   aList: TStrings;
 begin
@@ -781,5 +857,4 @@
   if FGraphType = GRAPH_FLOAT then
   begin
-    name := 'FBOUNDS';
     v1 := inttostr(Left);
     v2 := inttostr(Top);
@@ -787,53 +862,11 @@
     v4 := inttostr(Height);
     if WindowState = wsMaximized then
-      aList.Add(name + '^0,0,0,0')
+      aList.Add('FBOUNDS^0,0,0,0')
     else
-      aList.Add(name + '^' + v1 +',' + v2 +',' + v3 +',' + v4);
-    name := 'FWIDTH';
-    v1 := inttostr(splItemsTop.Left);
-    aList.Add(name + '^' + v1);
-    name := 'FBOTTOM';
-    if chkDualViews.Checked then
-      v1 := inttostr(pnlBottom.Height)
-    else
-      v1 := '0';
-    aList.Add(name + '^' + v1);
-    name := 'FCOLUMN';
-    v1 := inttostr(lvwItemsTop.Column[0].Width);
-    v2 := inttostr(lvwItemsTop.Column[1].Width);
-    v3 := inttostr(lvwItemsTop.Column[2].Width);
-    v4 := inttostr(lvwItemsTop.Column[3].Width);
-    aList.Add(name + '^' + v1 +',' + v2 +',' + v3 +',' + v4);
-    name := 'FBCOLUMN';
-    v1 := inttostr(lvwItemsBottom.Column[0].Width);
-    v2 := inttostr(lvwItemsBottom.Column[1].Width);
-    v3 := inttostr(lvwItemsBottom.Column[2].Width);
-    v4 := inttostr(lvwItemsBottom.Column[3].Width);
-    aList.Add(name + '^' + v1 +',' + v2 +',' + v3 +',' + v4);
+      aList.Add('FBOUNDS^' + v1 + ',' + v2 + ',' + v3 + ',' + v4);
+    Layout(aList, 'F', v1, v2, v3, v4);
   end
   else
-  begin
-    name := 'RWIDTH';
-    v1 := inttostr(splItemsTop.Left);
-    aList.Add(name + '^' + v1);
-    name := 'RBOTTOM';
-    if chkDualViews.Checked then
-      v1 := inttostr(pnlBottom.Height)
-    else
-      v1 := '0';
-    aList.Add(name + '^' + v1);
-    name := 'RCOLUMN';
-    v1 := inttostr(lvwItemsTop.Column[0].Width);
-    v2 := inttostr(lvwItemsTop.Column[1].Width);
-    v3 := inttostr(lvwItemsTop.Column[2].Width);
-    v4 := inttostr(lvwItemsTop.Column[3].Width);
-    aList.Add(name + '^' + v1 +',' + v2 +',' + v3 +',' + v4);
-    name := 'RBCOLUMN';
-    v1 := inttostr(lvwItemsBottom.Column[0].Width);
-    v2 := inttostr(lvwItemsBottom.Column[1].Width);
-    v3 := inttostr(lvwItemsBottom.Column[2].Width);
-    v4 := inttostr(lvwItemsBottom.Column[3].Width);
-    aList.Add(name + '^' + v1 +',' + v2 +',' + v3 +',' + v4);
-  end;
+    Layout(aList, 'R', v1, v2, v3, v4);
   rpcSetGraphSizing(aList);
   FreeAndNil(aList);
@@ -857,4 +890,5 @@
   PreSources: TStrings;
 begin
+  Application.ProcessMessages;
   okbutton := false;
   conv := btnChangeSettings.Tag;
@@ -868,19 +902,15 @@
     PreFixedDateRange := FixedDateRange;
     MaxSelectMin := Max(Max(lvwItemsTop.SelCount, lvwItemsBottom.SelCount), 1);
+    DateRangeOutpatient := FGraphSetting.DateRangeOutpatient;
   end;
   PreSources := TStringList.Create;
-  PreSources.Assign(FSources);
+  FastAssign(FSources, PreSources);
   DialogGraphSettings(Font.Size, okbutton, FGraphSetting, FSources, conv, aSettings);
   if not okbutton then exit;
-  if length(aSettings) > 0 then frmFrame.mnuToolsGraphing.Hint := aSettings;
+  if length(aSettings) > 0 then SetCurrentSetting(aSettings);
   btnChangeSettings.Tag := conv;
-  pnlInfo.Font.Size := lblViewsTop.Font.Size;
-  SetFontSize(lblViewsTop.Font.Size);
-  pnlInfo.Visible := conv > 0;
-  if conv > 0 then
-  begin
-    pnlInfo.Caption := TXT_WARNING;
-    pnlInfo.Color := COLOR_WARNING;
-  end;
+  pnlInfo.Font.Size := chkItemsTop.Font.Size;
+  SetFontSize(chkItemsTop.Font.Size);
+  InfoMessage(TXT_WARNING, COLOR_WARNING, (conv > 0));
   pnlHeader.Visible := pnlInfo.Visible;
   StayOnTop;
@@ -892,7 +922,10 @@
     begin
       FSources[i] := Pieces(sourcetype, '^', 2, 4);
-      filetype := Piece(FSources[i], '^', 1);
-      lstItems.Items.AddStrings(rpcGetItems(filetype, Patient.DFN));
-      needtoupdate := true;
+      if not FFastItems then
+      begin
+        filetype := Piece(FSources[i], '^', 1);
+        FastAddStrings(rpcGetItems(filetype, Patient.DFN), GtslItems);
+        needtoupdate := true;
+      end;
     end;
     if not needtoupdate then
@@ -921,11 +954,9 @@
   if lvwItemsTop.SelCount = 0 then
   begin
-    cboViewsTop.ItemIndex := -1;
-    cboViewsTop.Text := '';
+    lstViewsTop.ItemIndex := -1;
   end;
   if lvwItemsBottom.SelCount = 0 then
   begin
-    cboViewsBottom.ItemIndex := -1;
-    cboViewsBottom.Text := '';
+    lstViewsBottom.ItemIndex := -1;
   end;
 end;
@@ -957,4 +988,6 @@
   lvwItemsTop.Items.Clear;
   lvwItemsBottom.Items.Clear;
+  lvwItemsTop.Items.BeginUpdate;
+  lvwItemsBottom.Items.BeginUpdate;
   lvwItemsTop.SortType := stNone; // if Sorting during load then potential error
   lvwItemsBottom.SortType := stNone; // if Sorting during load then potential error
@@ -988,11 +1021,13 @@
     FItemsSortedBottom := false;
   end;
+  lvwItemsTop.Items.EndUpdate;
+  lvwItemsBottom.Items.EndUpdate;
 end;
 
 procedure TfrmGraphs.FilterListView(oldestdate, newestdate: double);
 var
-  colnum, i: integer;
+  i: integer;
   lastdate: double;
-  aProfile, filename, filenum, itemnum: string;
+  filename, filenum, itemnum: string;
 begin
   lvwItemsTop.Scroll(-BIG_NUMBER, -BIG_NUMBER);      //faster to set scroll at top
@@ -1004,5 +1039,4 @@
   if (cboDateRange.ItemIndex > 0) and (cboDateRange.ItemIndex < 9) then
   begin
-    with lvwItemsTop do
     if TypeIsDisplayed('405') then
       DateRangeItems(oldestdate, newestdate, '405');  // does not matter for all results ******************
@@ -1015,29 +1049,29 @@
     if TypeIsDisplayed('9999911') then
       DateRangeItems(oldestdate, newestdate, '9999911');
-    for i := 0 to lstItems.Items.Count - 1 do
-    begin
-      filenum := UpperCase(Piece(lstItems.Items[i], '^', 1));
+    for i := 0 to GtslItems.Count - 1 do
+    begin
+      filenum := UpperCase(Piece(GtslItems[i], '^', 1));
       if filenum <> '405' then
       if filenum <> '52' then
-        if filenum <> '55' then
-        if filenum <> '55NVA' then
-        if filenum <> '9999911' then
-          if TypeIsDisplayed(filenum) then
-          begin
-            lastdate := strtofloatdef(Piece(lstItems.Items[i], '^', 6), -BIG_NUMBER);
-            if (lastdate > oldestdate) and (lastdate < newestdate) then
-            begin
-              filename := FileNameX(filenum);
-              itemnum := Piece(lstItems.Items[i], '^', 2);
-              UpdateView(filename, filenum, itemnum, lstItems.Items[i], lvwItemsTop);
-            end;
-          end;
+      if filenum <> '55' then
+      if filenum <> '55NVA' then
+      if filenum <> '9999911' then
+      if TypeIsDisplayed(filenum) then
+      begin
+        lastdate := strtofloatdef(Piece(GtslItems[i], '^', 6), -BIG_NUMBER);
+        if (lastdate > oldestdate) and (lastdate < newestdate) then
+        begin
+          filename := FileNameX(filenum);
+          itemnum := Piece(GtslItems[i], '^', 2);
+          UpdateView(filename, filenum, itemnum, GtslItems[i], lvwItemsTop);
+        end;
+      end;
     end;
   end
   else if (cboDateRange.ItemIndex = 0) or (cboDateRange.ItemIndex > 8) then
   begin     // manual date range selection
-    for i := 0 to lstAllTypes.Items.Count - 1 do
-    begin
-      filenum := Piece(lstAllTypes.Items[i], '^', 1);
+    for i := 0 to GtslAllTypes.Count - 1 do
+    begin
+      filenum := Piece(GtslAllTypes[i], '^', 1);
       if TypeIsDisplayed(filenum) then
       begin
@@ -1047,4 +1081,12 @@
   end;
   lvwItemsBottom.Items.Assign(lvwItemsTop.Items);
+  SortListView;
+end;
+
+procedure TfrmGraphs.SortListView;
+var
+  colnum: integer;
+  aProfile: string;
+begin
   lvwItemsTop.SortType := stBoth;
   lvwItemsBottom.SortType := stBoth;
@@ -1069,7 +1111,7 @@
     FItemsSortedBottom := false;
   end;
-  if cboViewsTop.ItemIndex > 1 then                         // sort by view
-  begin
-    aProfile := cboViewsTop.Items[cboViewsTop.ItemIndex];
+  if lstViewsTop.ItemIndex > 1 then                         // sort by view
+  begin
+    aProfile := lstViewsTop.Items[lstViewsTop.ItemIndex];
     AssignProfile(aProfile, 'top');
     if not FItemsSortedTop then lvwItemsTopColumnClick(lvwItemsTop, lvwItemsTop.Column[colnum]);
@@ -1078,7 +1120,7 @@
     FItemsSortedTop := false;
   end;
-  if cboViewsBottom.ItemIndex > 1 then                      // sort by view
-  begin
-    aProfile := cboViewsBottom.Items[cboViewsBottom.ItemIndex];
+  if lstViewsBottom.ItemIndex > 1 then                      // sort by view
+  begin
+    aProfile := lstViewsBottom.Items[lstViewsBottom.ItemIndex];
     AssignProfile(aProfile, 'bottom');
     if not FItemsSortedBottom then lvwItemsBottomColumnClick(lvwItemsBottom, lvwItemsBottom.Column[colnum]);
@@ -1094,23 +1136,25 @@
   filename, itemnum, itemstuff, mitemnum: string;
 begin
-  FastAssign(rpcDateItem(oldestdate, newestdate, filenum, Patient.DFN), lstScratchTemp.Items);
+  FastAssign(rpcDateItem(oldestdate, newestdate, filenum, Patient.DFN), GtslScratchTemp);
   filename := FileNameX(filenum);
+  lvwItemsTop.Items.BeginUpdate;
   with lvwItemsTop do
-  for i := 0 to lstScratchTemp.Items.Count - 1 do
-  begin
-    itemstuff := lstScratchTemp.Items[i];
+  for i := 0 to GtslScratchTemp.Count - 1 do
+  begin
+    itemstuff := GtslScratchTemp[i];
     itemnum := UpperCase(Piece(itemstuff, '^',2));
-    for j := 0 to lstItems.Items.Count - 1 do
-    if (filenum = UpperCase(Piece(lstItems.Items[j], '^', 1))) and (itemnum = UpperCase(Piece(lstItems.Items[j], '^', 2))) then
-      UpdateView(filename, filenum, itemnum, lstItems.Items[j], lvwItemsTop);
+    for j := 0 to GtslItems.Count - 1 do
+    if (filenum = UpperCase(Piece(GtslItems[j], '^', 1))) and (itemnum = UpperCase(Piece(GtslItems[j], '^', 2))) then
+      UpdateView(filename, filenum, itemnum, GtslItems[j], lvwItemsTop);
     if filenum = '63' then
-    for j := 0 to lstMultiSpec.Items.Count - 1 do
-    begin
-      mitemnum := Piece(lstMultiSpec.Items[j], '^', 2);
+    for j := 0 to GtslMultiSpec.Count - 1 do
+    begin
+      mitemnum := Piece(GtslMultiSpec[j], '^', 2);
       if itemnum = Piece(mitemnum, '.', 1) then
         if DateRangeMultiItems(oldestdate, newestdate, mitemnum) then     //******** check specific date range
-          UpdateView(filename, filenum, mitemnum, lstMultiSpec.Items[j], lvwItemsTop);
-    end;
-  end;
+          UpdateView(filename, filenum, mitemnum, GtslMultiSpec[j], lvwItemsTop);
+    end;
+  end;
+  lvwItemsTop.Items.EndUpdate;
 end;
 
@@ -1134,5 +1178,5 @@
     aGraphItem := TGraphItem.Create;
     aGraphItem.Values := itemqualifier;
-    SubItems.AddObject('info object', aGraphItem);
+    SubItems.AddObject('', aGraphItem);
   end;
 end;
@@ -1146,8 +1190,8 @@
   Result := false;
   fileitem := '63^' + aMultiItem;
-  for i := 0 to lstData.Items.Count - 1 do
-    if Pieces(lstData.Items[i], '^', 1, 2) = fileitem then
-    begin
-      checkdate := strtofloatdef(Piece(lstData.Items[i], '^', 3), BIG_NUMBER);
+  for i := 0 to GtslData.Count - 1 do
+    if Pieces(GtslData[i], '^', 1, 2) = fileitem then
+    begin
+      checkdate := strtofloatdef(Piece(GtslData[i], '^', 3), BIG_NUMBER);
       if checkdate <> BIG_NUMBER then
         if checkdate >= aOldDate then
@@ -1166,11 +1210,10 @@
 begin
   Result := '';
-  with lstAllTypes do
-  for i := 0 to Items.Count - 1 do
-  begin
-    typestring := Items[i];
+  for i := 0 to GtslAllTypes.Count - 1 do
+  begin
+    typestring := GtslAllTypes[i];
     if Piece(typestring, '^', 1) = filenum then
     begin
-      Result := Piece(Items[i], '^', 2);
+      Result := Piece(GtslAllTypes[i], '^', 2);
       break;
     end;
@@ -1178,11 +1221,39 @@
   if Result = '' then
   begin
-    with lstAllTypes do
-    for i := 0 to Items.Count - 1 do
-    begin
-      typestring := Items[i];
+    for i := 0 to GtslAllTypes.Count - 1 do
+    begin
+      typestring := GtslAllTypes[i];
       if lowercase(Piece(typestring, '^', 1)) = filenum then
       begin
-        Result := Piece(Items[i], '^', 2);
+        Result := Piece(GtslAllTypes[i], '^', 2);
+        break;
+      end;
+    end;
+  end;
+end;
+
+function TfrmGraphs.TypeString(filenum: string): string;
+var
+  i: integer;
+  typestring: string;
+begin
+  Result := '';
+  for i := 0 to GtslAllTypes.Count - 1 do
+  begin
+    typestring := GtslAllTypes[i];
+    if Piece(typestring, '^', 1) = filenum then
+    begin
+      Result := typestring;
+      break;
+    end;
+  end;
+  if Result = '' then
+  begin
+    for i := 0 to GtslAllTypes.Count - 1 do
+    begin
+      typestring := GtslAllTypes[i];
+      if lowercase(Piece(typestring, '^', 1)) = filenum then
+      begin
+        Result := typestring;
         break;
       end;
@@ -1199,8 +1270,7 @@
   filenum := UpperCase(filenum);
   itemnum := UpperCase(itemnum);
-  with lstItems do
-  for i := 0 to Items.Count - 1 do
-  begin
-    typestring := UpperCase(Items[i]);
+  for i := 0 to GtslItems.Count - 1 do
+  begin
+    typestring := UpperCase(GtslItems[i]);
     if (Piece(typestring, '^', 1) = filenum) and
       (Piece(typestring, '^', 2) = itemnum) then
@@ -1212,48 +1282,124 @@
 end;
 
+procedure TfrmGraphs.Switch;
+var
+  aList: TStringList;
+begin
+  if FFastTrack then
+    exit;
+  aList := TStringList.Create;
+  if not FFastItems then
+  begin
+    rpcFastItems(Patient.DFN, aList, FFastItems);  // ***
+    if FFastItems then
+    begin
+      FastAssign(aList, GtslItems);
+      rpcFastData(Patient.DFN, aList, FFastData);  // ***
+      if FFastData then
+      begin
+        FastAssign(aList, GtslData);
+        aList.Clear;
+        rpcFastLabs(Patient.DFN, aList, FFastLabs);  // ***
+        if FFastLabs then
+          FastLab(aList);
+        FastAssign(GtslData, GtslCheck);
+      end;
+    end;
+  end;
+  if not FFastTrack then
+    FFastTrack := FFastItems and FFastData and FFastLabs;
+  if not FFastTrack then
+  begin
+    FFastItems := false;
+    FFastData := false;
+    FFastLabs := false;
+  end;
+  FreeAndNil(aList);
+end;
+
 procedure TfrmGraphs.InitialData;
 var
-  i, total: integer;
+  i: integer;
   dfntype, listline: string;
 begin
-  total := pnlData.ControlCount - 1;
-  with pnlData do
-  for i:= 0 to total do
-    if Controls[i] is TListBox then
-      if Controls[i] <> lstAllTypes then
-        if Controls[i] <> lstTestSpec then
-          (Controls[i] as TListBox).Items.Clear;
+  Application.ProcessMessages;
+  FMTimestamp := floattostr(FMNow);
   SourcesDefault;
-  FSources.Assign(FSourcesDefault);
-  btnChangeSettings.Tag :=0;
-  btnClose.Tag := 0;
-  cboViewsTop.Tag :=0;
-  chartDatelineTop.Tag :=0;
-  lvwItemsBottom.Tag :=0;
-  lvwItemsTop.Tag :=0;
-  pnlFooter.Parent.Tag :=0;
-  pnlItemsBottom.Tag :=0;
-  pnlItemsTop.Tag :=0;
-  pnlTop.Tag :=0;
-  scrlTop.Tag :=0;
-  splGraphs.Tag :=0;
-  cboViewsTop.ItemIndex := -1;
-  cboViewsBottom.ItemIndex := -1;
-  FastAssign(rpcGetTypes(Patient.DFN, false), lstTypes.Items);
-  for i := 0 to lstTypes.Items.Count - 1 do
-  begin
-    dfntype := UpperCase(Piece(lstTypes.Items[i], '^', 1));
-    if TypeIsLoaded(dfntype) then
-      lstItems.Items.AddStrings(rpcGetItems(dfntype, Patient.DFN));
-    listline := lstTypes.Items[i];
+  FastAssign(FSourcesDefault, FSources);
+  for i := 0 to GtslTypes.Count - 1 do
+  begin
+    listline := GtslTypes[i];
     dfntype := UpperCase(Piece(listline, '^', 1));
     SetPiece(listline, '^', 1, dfntype);
-    lstTypes.Items[i] := listline;
-  end;
-  lstTypes.Hint := Patient.DFN;  // use to check for patient change
-  FMTimestamp := floattostr(FMNow);
+    GtslTypes[i] := listline;
+  end;
+  btnChangeSettings.Tag := 0;
+  btnClose.Tag := 0;
+  lstViewsTop.Tag := 0;
+  chartDatelineTop.Tag := 0;
+  lvwItemsBottom.Tag := 0;
+  lvwItemsTop.Tag := 0;
+  pnlFooter.Parent.Tag := 0;
+  pnlItemsBottom.Tag := 0;
+  pnlItemsTop.Tag := 0;
+  pnlTop.Tag := 0;
+  scrlTop.Tag := 0;
+  splGraphs.Tag := 0;
+  lstViewsTop.ItemIndex := -1;
+  lstViewsBottom.ItemIndex := -1;
+  frmGraphData.pnlData.Hint := Patient.DFN;      // use to check for patient change
   FPrevEvent := '';
   FWarning := false;
   FFirstSwitch := true;
+  Application.ProcessMessages;
+  FFastData := false;
+  FFastItems := false;
+  FFastLabs := false;
+  FFastTrack := false;
+  if GraphTurboOn then
+    Switch;
+  //if not FFastItems then
+  if GtslItems.Count = 0 then
+  begin
+    for i := 0 to GtslTypes.Count - 1 do
+    begin
+      dfntype := Piece(GtslTypes[i], '^', 1);
+      if TypeIsLoaded(dfntype) then
+        FastAddStrings(rpcGetItems(dfntype, Patient.DFN), GtslItems);
+    end;
+  end;
+end;
+
+procedure TfrmGraphs.FastLab(aList: TStringList);
+var
+  lastone: boolean;
+  i: integer;
+  aType, aItem, aItemName, typeitem, oldtypeitem, listline: string;
+begin
+  if aList.Count < 1 then
+    exit;
+  GtslScratchLab.Clear;
+  aList.Sort;
+  listline := aList[0];
+  oldtypeitem := Pieces(listline, '^', 1, 2);
+  GtslScratchLab.Add(listline);
+  for i := 1 to aList.Count - 1 do
+  begin
+    lastone := i = aList.Count - 1;
+    listline := aList[i];
+    typeitem := Pieces(listline, '^', 1 , 2);
+    if (typeitem <> oldtypeitem) or lastone then
+    begin
+      if lastone then
+        oldtypeitem := typeitem;
+      aType := Piece(oldtypeitem, '^', 1);
+      aItem := Piece(oldtypeitem, '^', 2);
+      aItemName := MixedCase(ItemName(aType, aItem));
+      LabData(oldtypeitem, aItemName, 'top', false);  // already have lab data
+      GtslScratchLab.Clear;
+    end;
+    GtslScratchLab.Add(listline);
+    oldtypeitem := typeitem;
+  end;
 end;
 
@@ -1263,4 +1409,9 @@
   filetype: string;
 begin
+  if FFastItems then
+  begin
+    Result := true;
+    exit;
+  end;
   Result := false;
   for i := 0 to FSources.Count - 1 do
@@ -1300,5 +1451,5 @@
   with cboDateRange do
   begin
-    defaults := Items[Items.Count - 1];
+    defaults := Items[Items.Count - 1];        // ***** CHANGE TO DEFAULTS
     defaultrange := Piece(defaults, '^', 1);
     //get report views - param 1 and param 2
@@ -1307,5 +1458,7 @@
     //check if default range already exists
     if strtointdef(defaultrange, BIG_NUMBER) = BIG_NUMBER then
-      ItemIndex := Items.Count - 1;
+      ItemIndex := Items.Count - 1
+    else
+      ItemIndex := strtoint(defaultrange);
   end;
 end;
@@ -1332,5 +1485,5 @@
     filename := FileNameX(itemtype);
     FSources.Add(itemtype + '^' + filename + '^' + displayed);
-    lstItems.Items.AddStrings(rpcGetItems(itemtype, Patient.DFN));
+    FastAddStrings(rpcGetItems(itemtype, Patient.DFN), GtslItems);
   end;
 end;
@@ -1356,4 +1509,6 @@
 procedure TfrmGraphs.DisplayData(aSection: string);
 var
+  i: integer;
+  astring: string;
   aChart: TChart;
   aCheckBox: TCheckBox;
@@ -1361,26 +1516,21 @@
   aDateline, aRightPad: TPanel;
   aScrollBox: TScrollBox;
+  aMemo: TMemo;
 begin
   FHintStop := true;
-  SetFontSize(lblViewsTop.Font.Size);
+  SetFontSize(chkItemsTop.Font.Size);
   if aSection = 'top' then
   begin
-    aListView := lvwItemsTop;
-    aOtherListView := lvwItemsBottom;
-    aDateline := pnlDatelineTop;
-    aRightPad := pnlTopRightPad;
-    aScrollBox := scrlTop;
-    aChart := chartDatelineTop;
-    aCheckBox := chkItemsTop;
+    aListView := lvwItemsTop;         aOtherListView := lvwItemsBottom;
+    aDateline := pnlDatelineTop;      aChart := chartDatelineTop;
+    aRightPad := pnlTopRightPad;      aScrollBox := scrlTop;
+    aCheckBox := chkItemsTop;         aMemo := memTop;
   end
   else
   begin
-    aListView := lvwItemsBottom;
-    aOtherListView := lvwItemsTop;
-    aDateline := pnlDatelineBottom;
-    aRightPad := pnlBottomRightPad;
-    aScrollBox := scrlBottom;
-    aChart := chartDatelineBottom;
-    aCheckBox := chkItemsBottom;
+    aListView := lvwItemsBottom;      aOtherListView := lvwItemsTop;
+    aDateline := pnlDatelineBottom;   aChart := chartDatelineBottom;
+    aRightPad := pnlBottomRightPad;   aScrollBox := scrlBottom;
+    aCheckBox := chkItemsBottom;      aMemo := memBottom;
   end;
   if aListView.SelCount < 1 then
@@ -1389,6 +1539,5 @@
     begin
       FFirstClick := true;
-      while aScrollBox.ControlCount > 0 do
-        aScrollBox.Controls[0].Free;
+      while aScrollBox.ControlCount > 0 do aScrollBox.Controls[0].Free;
       exit;
     end;
@@ -1399,39 +1548,37 @@
     if aOtherListView.SelCount > 0 then
       if aOtherListView = lvwItemsTop then
-        ItemsClick(self, lvwItemsTop, lvwItemsBottom, chkItemsTop, cboViewsTop, lstSelCopyTop, 'top')
+        ItemsClick(self, lvwItemsTop, lvwItemsBottom, chkItemsTop, lstViewsTop, GtslSelCopyTop, 'top')
       else
-        ItemsClick(self, lvwItemsBottom, lvwItemsTop, chkItemsBottom, cboViewsBottom, lstSelCopyBottom, 'bottom');
+        ItemsClick(self, lvwItemsBottom, lvwItemsTop, chkItemsBottom, lstViewsBottom, GtslSelCopyBottom, 'bottom');
     exit;
   end;
   aScrollBox.VertScrollBar.Visible := false;
   aScrollBox.HorzScrollBar.Visible := false;
+  amemo.Visible := false;
   aChart.RemoveAllSeries;    // this would leave bottom dateline visible on date change
-  //chartDatelineTop.RemoveAllSeries;    // do both
-  //chartDatelineBottom.RemoveAllSeries; // do both
-  lstNonNumeric.Items.Clear;
+  for i := GtslNonNum.Count - 1 downto 0 do
+  begin
+    astring := GtslNonNum[i];
+    if Piece(astring, '^', 7) = aSection then
+      GtslNonNum.Delete(i);
+  end;
   if aCheckBox.Checked then
     MakeSeparate(aScrollBox, aListView, aRightPad, aSection)
   else
-  begin
-    MakeTogether(aScrollBox, aListView, aRightPad, aSection);
-  end;
+    MakeTogetherMaybe(aScrollBox, aListView, aRightPad, aSection);
+  DisplayDataInfo(aScrollBox, aMemo);
+end;
+
+procedure TfrmGraphs.DisplayDataInfo(aScrollBox: TScrollBox; aMemo: TMemo);
+begin
   ChangeStyle;
-  pnlInfo.Font.Size := lblViewsTop.Font.Size;
+  pnlInfo.Font.Size := chkItemsTop.Font.Size;
   if ((lvwItemsTop.SelCount > MAX_ITEM_DISCLAIMER) and (not chkItemsTop.Checked))
     or ((lvwItemsBottom.SelCount > MAX_ITEM_DISCLAIMER) and (not chkItemsBottom.Checked)) then
-  begin
-    pnlInfo.Caption := TXT_DISCLAIMER;
-    pnlInfo.Color := COLOR_WARNING;
-    pnlInfo.Visible := true;
-  end
+    InfoMessage(TXT_DISCLAIMER, COLOR_WARNING, true)
   else
     pnlInfo.Visible := false;
   if btnChangeSettings.Tag > 0 then
-  begin
-    pnlInfo.Caption := TXT_WARNING;
-    pnlInfo.Color := COLOR_WARNING;
-    pnlInfo.Visible := true;
-  end;
-  //if copy(pnlInfo.Caption, 1, 7) = 'Warning' then
+    InfoMessage(TXT_WARNING, COLOR_WARNING, true);
   if FWarning then
     pnlInfo.Visible := true;
@@ -1439,4 +1586,7 @@
   aScrollBox.VertScrollBar.Visible := true;
   aScrollBox.HorzScrollBar.Visible := false;
+  if (aScrollBox.ControlCount > FGraphSetting.MaxGraphs)
+  or (aScrollBox.Height < FGraphSetting.MinGraphHeight) then
+    aMemo.Visible:= true;
 end;
 
